function [IoutSC IoutSSC IoutLSC IoutLSSC] = demosaicking(I,D)
n=sqrt(size(D,1)/3);
k=size(D,2);
thrs=28;
J=3;  % number of passes over the training set for learning the dictionary
window=40; 
num_threads=1;  % use a single core (note that there is a bug in multi-threaded mode, which decreases the quality of the results when num_threads > 1)
lambda=3;  % gives very sparse decompositions

fprintf('compute the result obtained by SC\n');
[IoutSC D2]=mexDemos(I,I,D,1,1,num_threads,lambda,0,0);
fprintf('compute the result obtained by SSC (SC + group sparsity)\n');
[IoutSSC D2]=mexDemos2(I,I,D,1,1,num_threads,thrs,window,0,0,0);
fprintf('compute the result obtained by LSC (SC + dictionary learning)\n');
[IoutLSC D2]=mexDemos(I,I,D,1,1,num_threads,lambda,J,1);
fprintf('compute the result obtained by LLSC (SC + dictionary learning + group sparsity)\n');
% note that this function takes as an input the dictionary D2 returned by mexDemos
[IoutLSSC D2]=mexDemos2(I,I,D2,1,1,num_threads,thrs,window,J,0,lambda);
